/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.api.Comboitem;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.enums.TipoClasseServicoBPe;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;

/**
 *
 * @author Administrador
 */
@Controller("editarClaseServicioController")
@Scope("prototype")
public class EditarClaseServicioController extends MyGenericForwardComposer {
	private static final long serialVersionUID = 578894379723590151L;

    private static Logger log = LogManager.getLogger(EditarClaseServicioController.class);
	
	@Autowired
    private ClaseServicioService claseServicioService;
    private ClaseServicio claseServicio;
    private MyListbox claseServicioList;
    private MyTextbox txtNome;
    private MyComboboxEstandar cmbTipoServico;
    private Button btnApagar;
    private MyTextboxDecimal txtCoeficiente;
    private MyTextboxDecimal porcPricingSemelhante; 
    private Checkbox chkNaoVendeSeguroOpcional; 
    private Combobox cmbDescontoMonitrip;
    private List<TipoClasseServicoBPe> lsTipoDescontoMonitrips;

	@Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        claseServicio = (ClaseServicio) Executions.getCurrent().getArg().get("claseServicio");
        claseServicioList = (MyListbox) Executions.getCurrent().getArg().get("claseServicioList");
        lsTipoDescontoMonitrips = Arrays.asList(TipoClasseServicoBPe.values());
        lsTipoDescontoMonitrips = lsTipoDescontoMonitrips.subList(0, 7);
        if (claseServicio.getClaseservicioId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }else {
        	txtCoeficiente.setValue(null != claseServicio.getCoeficiente() && !"".equals(claseServicio.getCoeficiente()) ? claseServicio.getCoeficiente().toString() : "");

        }

        if (claseServicio.getTipoServicoBPe() == null) {
        	claseServicio.setTipoServicoBPe(TipoClasseServicoBPe.CONVENCIONAL_COM_SANITARIO.getCodigo());
        }

        cmbTipoServico.setValue(TipoClasseServicoBPe.getTipo(claseServicio.getTipoServicoBPe()).toString());
        chkNaoVendeSeguroOpcional.setChecked(claseServicio.getIndNaoVendeSeguroOpcional());
        
        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
    	BigDecimal vlrPorcPricingSemelhante = porcPricingSemelhante.getValueDecimal();
  
		if ((vlrPorcPricingSemelhante != null) && (vlrPorcPricingSemelhante.intValue() < 1 || vlrPorcPricingSemelhante.intValue() >= 100)) {
			Messagebox.show(
					Labels.getLabel("editarClaseServicioController.window.title"),
					Labels.getLabel("editarClaseServicioController.msgValidacaoPorcPricingSemelhante.title"),
					Messagebox.OK, Messagebox.INFORMATION);
			return;
		}
        txtNome.getText();
        cmbTipoServico.getValue();
        chkNaoVendeSeguroOpcional.getValue();
        
        try {
            Integer idClaseServicio = claseServicio.getClaseservicioId();
        	String nomeClaseServicio = claseServicio.getDescclase();
        	Integer idTipoClasseServicoBPe = claseServicio.getTipoServicoBPe();
        	
        	if(cmbTipoServico.getSelectedItem() != null) {
        		TipoClasseServicoBPe tipoClasseServicoBPe = (TipoClasseServicoBPe) cmbTipoServico.getSelectedItem().getValue();
        		idTipoClasseServicoBPe = tipoClasseServicoBPe.getCodigo();
        	}
            
            List<ClaseServicio> lsClaseServicio = claseServicioService.buscarPorNome(idClaseServicio, nomeClaseServicio);

            if (lsClaseServicio.isEmpty()) {
            	
            	claseServicio.setTipoServicoBPe(idTipoClasseServicoBPe);
                claseServicio.setActivo(Boolean.TRUE);
                claseServicio.setFecmodif(Calendar.getInstance().getTime());
                claseServicio.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
                claseServicio.setCoeficiente(null != txtCoeficiente.getText() && !"".equals(txtCoeficiente.getText()) ? new BigDecimal(txtCoeficiente.getText()) : null);
                claseServicio.setIndNaoVendeSeguroOpcional(chkNaoVendeSeguroOpcional.isChecked());
                
                Comboitem cbDescontoMonitrip = cmbDescontoMonitrip.getSelectedItem();
                claseServicio.setTipoDescontoMonitrip(null);
                if(cbDescontoMonitrip != null) {
                	claseServicio.setTipoDescontoMonitrip((TipoClasseServicoBPe) cbDescontoMonitrip.getValue());
                }
                
                if (claseServicio.getClaseservicioId() == null) {
                    claseServicioService.suscribir(claseServicio);
                    claseServicioList.addItem(claseServicio);
                } else {
                    claseServicioService.actualizacion(claseServicio);
                    claseServicioList.updateItem(claseServicio);
                }

                Messagebox.show(
                        Labels.getLabel("editarClaseServicioController.MSG.suscribirOK"),
                        Labels.getLabel("editarClaseServicioController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarClaseServicioController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }
        } catch (Exception ex) {
            log.error("editarClaseServicioController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarClaseServicioController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) throws InterruptedException {        
        int resp = Messagebox.show(
                Labels.getLabel("editarClaseServicioController.MSG.borrarPergunta"),
                Labels.getLabel("editarClaseServicioController.window.title"),
                Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

        if (resp == Messagebox.YES) {
            claseServicioService.borrar(claseServicio);

            Messagebox.show(
                    Labels.getLabel("editarClaseServicioController.MSG.borrarOK"),
                    Labels.getLabel("editarClaseServicioController.window.title"),
                    Messagebox.OK, Messagebox.INFORMATION);

            claseServicioList.removeItem(claseServicio);

            closeWindow();
        }
    }
    
    public ClaseServicio getClaseServicio() {
        return claseServicio;
    }

    public void setClaseServicio(ClaseServicio claseServicio) {
        this.claseServicio = claseServicio;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public MyTextboxDecimal getTxtCoeficiente() {
		return txtCoeficiente;
	}

	public void setTxtCoeficiente(MyTextboxDecimal txtCoeficiente) {
		this.txtCoeficiente = txtCoeficiente;
	}
    
    public List<TipoClasseServicoBPe> getTiposClasseServicoBPe() {
    	return TipoClasseServicoBPe.getList();
    }

	public Combobox getCmbDescontoMonitrip() {
		return cmbDescontoMonitrip;
	}

	public void setCmbDescontoMonitrip(Combobox cmbDescontoMonitrip) {
		this.cmbDescontoMonitrip = cmbDescontoMonitrip;
	}

	public List<TipoClasseServicoBPe> getLsTipoDescontoMonitrips() {
		return lsTipoDescontoMonitrips;
	}

	public void setLsTipoDescontoMonitrips(List<TipoClasseServicoBPe> lsTipoDescontoMonitrips) {
		this.lsTipoDescontoMonitrips = lsTipoDescontoMonitrips;
	}

	public MyTextboxDecimal getPorcPricingSemelhante() {
		return porcPricingSemelhante;
	}

	public void setPorcPricingSemelhante(MyTextboxDecimal porcPricingSemelhante) {
		this.porcPricingSemelhante = porcPricingSemelhante;
	}

	  
}
